/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	kumoriv1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis/kumori/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeKukuHttpInbounds implements KukuHttpInboundInterface
type FakeKukuHttpInbounds struct {
	Fake *FakeKumoriV1
	ns   string
}

var kukuhttpinboundsResource = schema.GroupVersionResource{Group: "kumori.systems", Version: "v1", Resource: "kukuhttpinbounds"}

var kukuhttpinboundsKind = schema.GroupVersionKind{Group: "kumori.systems", Version: "v1", Kind: "KukuHttpInbound"}

// Get takes name of the kukuHttpInbound, and returns the corresponding kukuHttpInbound object, and an error if there is any.
func (c *FakeKukuHttpInbounds) Get(name string, options v1.GetOptions) (result *kumoriv1.KukuHttpInbound, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(kukuhttpinboundsResource, c.ns, name), &kumoriv1.KukuHttpInbound{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.KukuHttpInbound), err
}

// List takes label and field selectors, and returns the list of KukuHttpInbounds that match those selectors.
func (c *FakeKukuHttpInbounds) List(opts v1.ListOptions) (result *kumoriv1.KukuHttpInboundList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(kukuhttpinboundsResource, kukuhttpinboundsKind, c.ns, opts), &kumoriv1.KukuHttpInboundList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &kumoriv1.KukuHttpInboundList{ListMeta: obj.(*kumoriv1.KukuHttpInboundList).ListMeta}
	for _, item := range obj.(*kumoriv1.KukuHttpInboundList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested kukuHttpInbounds.
func (c *FakeKukuHttpInbounds) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(kukuhttpinboundsResource, c.ns, opts))

}

// Create takes the representation of a kukuHttpInbound and creates it.  Returns the server's representation of the kukuHttpInbound, and an error, if there is any.
func (c *FakeKukuHttpInbounds) Create(kukuHttpInbound *kumoriv1.KukuHttpInbound) (result *kumoriv1.KukuHttpInbound, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(kukuhttpinboundsResource, c.ns, kukuHttpInbound), &kumoriv1.KukuHttpInbound{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.KukuHttpInbound), err
}

// Update takes the representation of a kukuHttpInbound and updates it. Returns the server's representation of the kukuHttpInbound, and an error, if there is any.
func (c *FakeKukuHttpInbounds) Update(kukuHttpInbound *kumoriv1.KukuHttpInbound) (result *kumoriv1.KukuHttpInbound, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(kukuhttpinboundsResource, c.ns, kukuHttpInbound), &kumoriv1.KukuHttpInbound{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.KukuHttpInbound), err
}

// Delete takes name of the kukuHttpInbound and deletes it. Returns an error if one occurs.
func (c *FakeKukuHttpInbounds) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(kukuhttpinboundsResource, c.ns, name), &kumoriv1.KukuHttpInbound{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeKukuHttpInbounds) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(kukuhttpinboundsResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &kumoriv1.KukuHttpInboundList{})
	return err
}

// Patch applies the patch and returns the patched kukuHttpInbound.
func (c *FakeKukuHttpInbounds) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *kumoriv1.KukuHttpInbound, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(kukuhttpinboundsResource, c.ns, name, pt, data, subresources...), &kumoriv1.KukuHttpInbound{})

	if obj == nil {
		return nil, err
	}
	return obj.(*kumoriv1.KukuHttpInbound), err
}
